#!/bin/bash

# nice display of information from a solvetrace file
# name of solvetrace file should be passed as first argument
# keeps running to display newly added lines


# fields are lineNum, seriesID, node, seconds, bestFound, bestBound

tail -n 100 -f $1 | \
awk -F, '
function abs(a) { return a >= 0 ? a : -a }
BEGIN {
  wtime=8
  wnode=6
  wprimal=15
  wdual=15
  wgap=8
  headerform="%" wtime-1 "s |%-" wnode "s |%-" wdual "s|%-" wprimal "s|%-" wgap "s\n"
  dataform="%" wtime-1 ".2fs|%" wnode "d |%" wdual-1 "e |%" wprimal-1 "e |%" wgap-1 ".2f%%" "\n"
  headcount=0
}
/trace file.*ID = / { print substr($0, index($0, "ID = ")+5); next; }
/^*/ { next; }
//   {
  if( headcount == 0 )
  {
      printf(headerform, "time", " nodes", "  dualbound", "  primalbound", "  gap");
      headcount = 10;
  }
  if( abs($5) > abs($6) ) scale = abs($5);
  if( scale < 1 ) scale = 1;
  gap = 100.0 * ($5 - $6) / (scale*1.0);
  printf(dataform, $4, $3, $6, $5, gap);
  headcount--;
}
'

